module HTTPLogAnalyzer

  class Element

    def self.parse(string)
      $cache ||= {}
      $cache[self] ||= {}
      $cache[self][string] ||= new.tap { |e| e.parse(string) }
    end

    def normalize_uri!(uri)
      uri.normalize!
      uri.scheme = 'http' if uri.scheme == 'https'
      uri.host = uri.host.downcase.sub(/^(www|m)\./, '').sub(/\.$/, '') if uri.host
    end

  end

end