module HTTPLogAnalyzer

  class Element

    class Request < Element

      attr_accessor :uri
      attr_accessor :mime_types

      def parse(string)
        @method, uri_string, @version = string.split(/\s+/)
        @uri = Addressable::URI.parse(uri_string) or raise ParseError, "Can't parse URI: #{uri_string}"
        normalize_uri!(@uri)
        @mime_types = MIME::Types.type_for(@uri.path)
      end

    end

  end

end