module HTTPLogAnalyzer

  class Element

    class Source < Element

      attr_accessor :address
      attr_accessor :country
      attr_accessor :region
      attr_accessor :city

      def parse(string)
        result = $geo_ip.city(string)
        if result
          city, region, country = %i{city_name real_region_name country_name}.map do |key|
            value = result.send(key)
            value.to_s.empty? ? nil : value
          end
          @address = result.ip
          @country = country
          @region = [region, country].join(', ') if region
          @city = [city, region, country].join(', ') if city
        else
          @ip = string
        end
      end

    end

  end

end