module HTTPLogAnalyzer

  class Entry

    attr_accessor :timestamp
    attr_accessor :source
    attr_accessor :request
    attr_accessor :status
    attr_accessor :referer
    attr_accessor :user_agent

    def initialize(info)
      # 12/Feb/2016:09:59:04 +0000
      @timestamp = DateTime.strptime(info[:datetime], '%d/%b/%Y:%H:%M:%S %Z')
      @source = Element::Source.parse(info[:ip])
      @request = Element::Request.parse(info[:request])
      @status = Element::Status.parse(info[:status])
      @referer = Element::Referer.parse(info[:referer])
      @user_agent = Element::UserAgent.parse(info[:user_agent])
    end

    def calendar_week
      '%s - %s' % [1, 7].map { |d| DateTime.commercial(@timestamp.year, @timestamp.cweek, d).to_date }
    end

  end

end